#ifndef CYGONCE_ISO_ASSERT_H
#define CYGONCE_ISO_ASSERT_H

# ifdef NDEBUG
#  define assert( __bool ) ((void)0)
# else /* if NDEBUG is NOT defined */

/* First preference is to be standards compliant */

# define assert( __bool )                                                 \
    do {                                                                  \
        if (0 == (__bool)) {                                              \
            diag_printf("User assertion failed: \"%s\", at %s:%d\n", \
                         #__bool, __FILE__, __LINE__);                    \
            abort();                                                      \
        }                                                                 \
    } while(0)

# endif /* NDEBUG not defined */
#endif /* CYGONCE_ISO_ASSERT_H multiple inclusion protection */
